unit UP2CGI;

interface

type

  TPCGI=^TCGI;
  
  TCGI=object

    private
    
      LstQStr: P_TQString;
      LstStrRen: t_ptr_str_pair;
      function ChecarLinha(Linha: String; StrRename: t_ptr_str_pair): String;
      function SubsStr(var StrRename: t_ptr_str_pair; str_org: String): String;
  
    public
    
      Procedure WebGenHTML(var StrRename: t_ptr_str_pair; filename: String);
      Constructor Init(var PTQStr_Raiz: P_TQString; qString: String);
      Procedure WebFormDecode(var PTQStr_Raiz: P_TQString; qString: String);
      function WebGetVarContent(PTQStr_Raiz: P_TQString; strName: String): String;
      Procedure WebStrRename(var StrRename: t_ptr_str_pair; str_org, str_new: String);
      Destrutor Finish;

  end;


uses escreq, BD;


function TCGI.WebGetVarContent(PTQStr_Raiz: P_TQString; strName: String): String;
var
 Achou: Boolean;
 PTQStr: P_TQString;
begin
  Achou:=false;
  PTQStr:=PTQStr_Raiz;
  While (PTQStr<>nil)and(not Achou) do
  begin
    If PTQStr^.Nome=strName then
    begin
      Achou:=true;
      WebGetVarContent:=PTQStr^.Valor;
    end
    else
      PTQStr:=PTQStr^.Prox;
  end;
end;

procedure TCGI.WebFormDecode(var PTQStr_Raiz: P_TQString; qString: String);
var
 I: Integer;
 NomeCampo, ValorCampo: String;
 PTQStr, PTQStr_Novo: P_TQString;
 AntesIgual: Boolean;
begin
  qString:=escapeSequenceReverse(qString);
  If Length(qString)=0 then
    Exit;
  If PTQStr<>nil then
    LimparLstEncadeada(PTQStr_Raiz);
  New(PTQStr_Raiz);
  PTQStr:=nil;
  NomeCampo:='';
  ValorCampo:='';
  AntesIgual:=true;
  For I:=1 to Length(qString) do
  begin
    If qString[I]='=' then
      AntesIgual:=false
    else
    If (qString[I]='&') or (I=Length(qString)) then
    begin
      If PTQStr=nil then
        PTQStr_Novo:=PTQStr_Raiz
      else
        New(PTQStr_Novo);
      PTQStr_Novo^.Nome:=NomeCampo;
      PTQStr_Novo^.Valor:=ValorCampo;
      PTQStr_Novo^.Prox:=nil;
      If PTQStr=nil then
        PTQStr:=PTQStr_Novo
      else
      begin
        PTQStr^.Prox:=PTQStr_Novo;
        PTQStr:=PTQStr_Novo;
      end;
      NomeCampo:='';
      ValorCampo:='';
      AntesIgual:=true;
    end
    else
    If AntesIgual then
      NomeCampo:=NomeCampo+qString[I]
    else
      ValorCampo:=ValorCampo+qString[I];
  end;
end;

function TCGI.SubsStr(var StrRename: t_ptr_str_pair; str_org: String): String;
  var
    PStrRen: t_ptr_str_pair;
  begin
    PStrRen:=StrRename;
    While (PStrRen^.str_org<>str_org)and(PStrRen^.Prox<>nil) do
      PStrRen:=PStrRen^.Prox;
    If PStrRen=nil then
      SubsStr:=''
    else
      SubsStr:=PStrRen^.str_new;
  end;

function TCGI.ChecarLinha(Linha: String; StrRename: t_ptr_str_pair): String;
  var
    I: Integer;
    str_org, StrResp: String;
    PegandoStrOrg: Boolean;
    LstDados_Raiz: P_LstTDados;
  begin
    If StrRename=nil then
    begin  {Caso nao existam nomes para serem alterados}
      ChecarLinha:=Linha;
      Exit;
    end;
    PegandoStrOrg:=false;
    str_org:='';
    StrResp:='';
    For I:=1 to Length(Linha) do
    begin
      If not PegandoStrOrg then
      begin
        If (Linha[I]='|') then
          PegandoStrOrg:=true
        else
          StrResp:=StrResp+Linha[I];
      end
      else
      begin
        If Linha[I]='|' then
        begin
          If str_org='LstCont' then
          begin
            Gerar_LstContatos(LstDados_Raiz);
            Imp_LstContatos(LstDados_Raiz);
            StrResp:='<BR>';
          end
          else
            StrResp:=StrResp+SubsStr(StrRename,str_org); 
          PegandoStrOrg:=false;
          str_org:='';
        end
        else
          str_org:=str_org+Linha[I];
      end;
    end;
    ChecarLinha:=StrResp;
  end;

procedure TCGI.WebGenHTML(var StrRename: t_ptr_str_pair; filename: string);
var
  arqHTML: textfile;
  Linha: String;
begin
  Assign(arqHTML,filename);
  Reset(arqHTML);
  While not EOF(arqHTML) do
  begin
    ReadLn(arqHTML,Linha);
    WriteLn(ChecarLinha(Linha,StrRename));
  end;
end;


procedure TCGI.WebStrRename(var StrRename: t_ptr_str_pair; str_org, str_new: String);
var
  PStrRen, PStrRen_Novo: t_ptr_str_pair;
begin
  PStrRen:=StrRename;
  New(PStrRen_Novo);
  PStrRen_Novo^.str_org:=str_org;
  PStrRen_Novo^.str_new:=str_new;
  PStrRen_Novo^.Prox:=nil;
  If PStrRen=nil then
  begin
    PStrRen:=PStrRen_Novo;
    StrRename:=PStrRen;
  end
  else
  begin
    while PStrRen^.Prox<>nil do
      PStrRen:=PStrRen^.Prox;
    PStrRen^.Prox:=PStrRen_Novo;
  end;
end;

destrutor TCGI.Finish;
var
  LstQStr_Ant: P_TQString;
  LstStrRen_Ant: t_ptr_str_pair;
begin
  while LstQStr<>nil do
  begin
    LstQStr_Ant:=LstQStr;
    LstQStr:=LstQStr^.Prox;
    Dispose(LstQStr_Ant);
  end;
  While LstStrRen<>nil then
  begin
    LstStrRen_Ant:=LstStrRen;
    LstStrRen:=LstStrRen^.Prox;
    Dispose(LstStrRen_Ant);
  end;
end;

Constructor TCGI.Init(var PTQStr_Raiz: P_TQString; qString: String);
var
  PTQStr: P_TQString;

begin
  If (LstStrRen<>nil) or (LstQStr<>nil) then
    Finish;
  While PTQStr_Raiz<>nil do
  begin
    PTQStr:=PTQStr_Raiz;
    PTQStr_Raiz:=PTQStr_Raiz^.Prox;
    Dispose(PTQStr);
  end;  
  WebFormDecode(PTQStr_Raiz,qString);
  LstQStr:=nil;
  LstStrRen:=nil;
end;

end.
