unit BD;

interface

type

   P_TQString=^TQString;

   TQString=Record
       Nome, Valor: String;
       Prox: P_TQString;
   end;

   t_ptr_str_pair=^TStrRename;
 
   TStrRename=record
     str_org, str_new: String;
     Prox: t_ptr_str_pair;
   end;

   TCont = record
     NomeCont: String;
     Endereco: String;
     TelRes, TelCom, TelCel, Obs: String;
   end;

   P_LstTCont=^LstTCont;

   LstTCont=record
     Cont: TCont;
     Prox: P_LstTDados;
   end;

   t_arqcont = file of TCont;

Function AbrirArqCont(CaminhoArq: String; var arqcont: t_arqdados; Criar: Boolean): Boolean;
Procedure EscrevaArqCont(var arqcont: t_arqdados;var NovoCont: TCont);
Procedure EscreveArq2(PTLstDados_Raiz: P_LstTDados; PathStr: String);
Procedure FecheArqCont(var arqcont: t_arqcont);
Procedure ApagueArqCont(var arqcont: t_arqcont);
Procedure LerArqCont(var PTLstCont_Raiz: P_LstTCont; var arqcont: T_arqcont);
Procedure LimparLstCont(var PTLstCont_Raiz: P_LstTCont);
Procedure OrdenarLstCont(var PTLstCont_Raiz: P_LstTCont; Campo: String);
Procedure ImpLstCont(PTLstCont_Raiz: P_LstTCont; PalavCh: String);
Procedure ApagarCont(var arqcont: t_arqcont; Nome: String);

implementation

Procedure ApagarCont(var arqcont: t_arqcont; Nome: String);
var
  PTLstCont_Raiz, PTLstCont: P_LstTCont;
begin
  LerArqCont(PTLstCont_Raiz,arqcont);
  ReWrite(arqcont);
  PTLstCont:=PTLstCont_Raiz;
  While PTLstCont<>nil do
  begin
    If PTLstCont^.Cont.NomeCont<>Nome then
      Write(arqcont,PTLstCont^.Cont);
    PTLstCont:=PTLstCont^.Prox;
  end;
  LimparLstCont(PTLstCont_Raiz);
end;

Procedure ImpLstCont(PTLstCont_Raiz: P_LstTCont; PalavCh: String);
var
  PTLstCont: P_LstTCont;
  Achou: Boolean;
  
  function ProcurarPalavCh(Texto, PalavCh: String): Boolean;
  var 
    Achou: Boolean;
    I: Integer;
    ContCharIguais: Byte;
  begin
    If PalavCh='' then
    begin
      ProcurarPalavCh:=true;
      Exit;
    end
    else
      Achou:=false;
    Texto:=UpperCase(Texto);
    PalavCh:=UpperCase(PalavCh);
    If Lenght(Texto)>=Lenght(PalavCh) then
    begin
      ContCharIguais:=1;
      For I:=1 to Lenght(Texto) do
      begin
        If Texto[I]=PalavCh[ContCharIguais] then
          ContCharIguais:=ContCharIguais+1
        else
          ContCharIguais:=1;
        If ContCharIguais=Lenght(PalavCh) then
        begin
          Achou:=true;
          Break;
        end;
      end;
    end;
    ProcurarPalavCh:=Achou;
  end;


begin
  PTLstCont:=PTLstCont_Raiz;
  While PTLstCont<>nil do
  begin
    Achou:=ProcurarPalavCh(PTLstCont^.Cont.NomeCont,PalavCh);
    If not Achou then
    begin
      Achou:=ProcurarPalavCh(PTLstCont^.Cont.Endereco,PalavCh);
      If not Achou then
        Achou:=ProcurarPalavCh(PTLstCont^.Cont.Obs,PalavCh);
    end;
    If Achou then
      ImpCont(PTLstCont^.Cont);
    PTLstCont:=PTLstCont^.Prox;
  end;
end;

Procedure OrdenarLstCont(var PTLstCont_Raiz: P_LstTCont; Campo: String);
var 
  PTLstCont, PTLstCont_Ant, PTLstCont_Base, PTLstCont_Base_Ant, PTLstCont_Aux: P_LstTCont;
  Troca: Boolean;
begin
  If PTLstCont_Raiz<>nil then
  begin
    PTLstCont_Base:=PTLstCont_Raiz;
    PTLstCont_Base_Ant:=nil;
    While PTLstCont_Base<>nil do
    begin
      PTLstCont:=PTLstCont_Base;
      PTLstCont:=PTLstCont_Base_Ant;
      While PTLstCont<>nil do
      begin
        Troca:=false;
        If Campo='Nome' then
        begin
          If PTLstCont^.Nome<PTLstCont_Base^.Nome then
            Troca:=true;
        end
        else
        If Campo='Endereco' then
        begin
          If PTLstCont^.Endereco<PTLstCont_Base^.Endereco then
            Troca:=true;
	end;
        If Troca then
        begin
          PTLstCont_Aux:=PTLstCont_Base;
          PTLstCont_Base:=PTLstCont;
	  PTLstCont_Base_Ant^.Prox:=PTLstCont;
	  PTLstCont:=PTLstCont_Aux;
	  PTLstCont_Ant^.Prox:PTLstCont_Aux;
        end; 
        PTLstCont_Ant:=PTLstCont;
        PTLstCont:=PTLstCont^.Prox;
      end;  
      PTLstCont_Base_Ant:=PTLstContBase;
      PTLstCont_Base:=PTLstCont_Base^.Prox;
    end;
  end;
end;

Procedure LimparLstCont(var PTLstCont_Raiz: P_LstTCont);
var
  PTLstCont: P_LstTCont
begin
  While PTLstCont_Raiz<>nil do
  begin 
    PTLstCont:=PTLstCont_Raiz;
    PTLstCont_Raiz:=PTLstCont_Raiz^.Prox;
    Dispose(PTLstCont);
  end;
end;

Procedure EscreveArq2(PTLstDados_Raiz: P_LstTDados; PathStr: String);
var
  PTLstDados: P_LstTDados;
  arqdados: t_arqdados;
begin
  PTLstDados:=PTLstDados_Raiz;
  AbrirArq(PathStr,arqdados,true);
  ReWrite(arqdados);
  While PTLstDados<>nil do
  begin
    Write(arqdados,PTLstDados^.Dados);
    PTLstDados:=PTLstDados^.Prox;
  end;
  FecheArq(arqdados);
end;

procedure Imp_LstContatos(PTQStr_Raiz: P_LstTDados);
var
  PTQStr: P_LstTDados;
  Cont: Integer;
  S: String;
begin
  Cont:=0;
  PTQStr:=PTQStr_Raiz; 
  While PTQStr<>nil do
  begin
    Cont:=Cont+1;
    Str(Cont,S);
    WriteLn(S+'-'+ PTQStr^.Dados.NomeCont +'<BR>');
    WriteLn('Endereco: '+ PTQStr^.Dados.Endereco +'<BR>');
    WriteLn('Tel. Comercial: '+ PTQStr^.Dados.TelCom +'<BR>');
    WriteLn('Tel. Celular: '+ PTQStr^.Dados.TelCel +'<BR>');
    WriteLn('Tel. Residencial: '+ PTQStr^.Dados.TelRes +'<BR>');
    WriteLn('Observao: '+ PTQStr^.Dados.Obs +'<BR>');
    WriteLn('<BR><BR>');
    PTQStr:=PTQStr^.Prox;
  end;
end; 

Procedure LerArqCont(var PTLstCont_Raiz: P_LstTCont; var arqcont: T_arqcont);
var
  PTLstCont, PTLstCont_Ant: P_LstTCont;
begin
  If PTLstCont_Raiz<>nil then
    LimparLstCont(PTLstCont_Raiz);
  Reset(arqCont);
  PTLstCont:=nil;
  While not(Eof(arqCont)) do
  begin
    PTLstCont_Ant:=PTLstCont;
    New(PTLstCont);
    Read(arqCont,PTLstCont^.Cont);
    If PTLstCont_Ant<>nil then
      PTLstCont_Ant^.Prox:=PTLstCont
    else
      PTLstCont_Raiz:=PTLstCont;
  end;
end;

Procedure ApagueArq(var arqdados: t_arqdados);
begin
  Erase(arqdados);
end;

Procedure FecheArq(var arqdados: t_arqdados);
begin
  close(arqdados);
end;

Procedure EscrevaArqCont(var arqcont: t_arqdados;var NovoCont: TCont);
begin
  Write(arqcont,NovoCont);
end;

Function AbrirArq(CaminhoArq: String; var arqdados: t_arqdados; Criar: Boolean): Boolean;
  function CheckFile: Boolean;
  begin
    {$I-}
    Reset(arqdados);
    {$I+}
    CheckFile:=true;
    If IOResult=0 then
    begin
      Seek(arqdados,filesize(arqdados));
    end
    else
    begin
      If Criar then
        ReWrite(arqdados)
      else
        CheckFile:=false;
    end;
  end;
begin
  Assign(arqdados,CaminhoArq);
  AbrirArq:=CheckFile;
end;

end.