UNIT EscSeq;

INTERFACE

         {
          PROCEDURE <escapeSequenceReverse>: converte uma string no formato
          'escape-sequence' - <esc_seq> - para o formato normal.
         }

         procedure escapeSequenceReverse (var esc_seq: string);


IMPLEMENTATION

         {
          PROCEDURE <replaceChar>: substitui, em uma string - <str> - todos os caracteres iguais a
          <old> pelo caracter <new>.

          -> varre a string <str> verificando se h ocorrncias do caracter <old>;
             quando encontra <old>, o remove e insere <new> em seu lugar.

          * vide System Unit / <procedure Delete>
                               <procedure Insert>
         }

         procedure replaceChar(var str: string; old, nw: char);

                  var i: integer;

                  begin
                       for i:=1 to length(str) do
                           if str[i] = old then
                              begin
                                   delete(str, i, 1);
                                   insert(nw, str, i);
                              end;
                  end;


         {
          FUNCTION <hexToDec>: recebe um caracter representando um dgito hexadecimal -
          <ch_hex> - e retorna, em um inteiro, seu valor decimal.

          -> converte o caracter <ch_hex> para maisculo;
             se <ch_hex> for um valor entre '0' e '9', atribui  varivel <dec> a diferena
                entre os cdigos ASCII de <ch_hex> e '0';
             seno (<ch_hex>  um valor entre 'A' e 'F'), atribui  varivel <dec> a diferena
                entre os cdigos ASCII de <ch_hex> e 'A' mais 10 unidades;
             retorna <dec>.

          * vide System Unit / <function UpCase>
                               <function Ord>
         }

         function hexToDec (ch_hex: char): integer;

                  var ch: char;
                      dec: integer;

                  begin
                      ch := upCase(ch_hex);

	              if (ord(ch) < (ord('9')+1)) then
                         dec := ord(ch) - ord('0')
	              else
                         dec := ord(ch) - ord('A') + 10;

	              hexToDec := dec;
                  end;


         {
          FUNCTION <toHexReverse>: recebe um string de 2 caracteres representando um valor
          hexadecimal - <str_hex> - e retorna o caracter associado a este valor na tabela ASCII.

          -> atribui  varivel <msb> o valor decimal correspondente ao 1 caracter da string
                     <str_hex>;
             atribui  varivel <lsb> o valor decimal correspondente ao 2 caracter da string
                     <str_hex>;
             atribui  varivel <dec> o valor decimal correspondente a <str_hex>;
             atribui  varivel <ret> o caracter associado a <dec> na tabela ASCII;
             retorna <ret>.

          * vide <function hexToDec>
          * vide System Unit / <function Chr>
         }

         function toHexReverse (str_hex: string): char;

                  var ret: char;
                      dec, msb, lsb: integer;

                  begin
                       msb := hexToDec( str_hex[1] );
	               lsb := hexToDec( str_hex[2] );
                       dec := lsb + msb*16;
                       ret := chr(dec);

                       toHexReverse := ret;
                  end;


         {
          PROCEDURE <escapeSequenceReverse>: converte uma string no formato
          'escape-sequence' - <esc_seq> - para o formato normal.

          -> substitui, na string <esc_seq>, todos os caracteres '+' por espaos em branco;
             varre <esc_seq> verificando se h ocorrncias do caracter '%' (incio de cdigo
                   ASCII hexadecimal);
             quando encontra '%':
                    - atribui  varivel <str_hex> os 2 caracteres subseqentes a '%';
                    - atribui  varivel <ch> o caracter associado ao cdigo ASCII em <str_hex>;
                    - remove de <esc_seq> os caracteres correspondentes ao cdigo hexadecimal
                      (incluindo o '%') e insere <ch> em seu lugar.

          * vide <procedure replaceChar>
                 <function toHexReverse>
          * vide System Unit / <function Length>
                               <function Copy>
                               <procedure Delete>
                               <procedure Insert>
         }

         procedure escapeSequenceReverse (var esc_seq: string);

                  var i: integer;
                      str_hex: string[2];
                      ch: char;

                  begin
                       replaceChar(esc_seq, '+', ' ');

                       for i:=1 to length(esc_seq) do
                           if esc_seq[i] = '%' then
                              begin
                                   str_hex := copy(esc_seq, i+1, 2);
                                   ch := toHexReverse(str_hex);
                                   delete(esc_seq, i, 3);
                                   insert(ch, esc_seq, i);
                              end;
                  end;

END.
